
#include "common.h"
#include "Console.h"
#include "Player.h"
#include "Enemy.h"

Player player;

char PlayerShot = '|';	
char EnemyShot = '*';	

#define PLAYER_SHOT        0	
#define ENEMY_SHOT         1	

struct ShotInfo 
{
	int x, y;		
	int Type;		
	int UseFlag;
};

#define MAX_SHOT_COUNT      30						
struct ShotInfo            Shot[MAX_SHOT_COUNT];	

#define MAX_ENEMY_COUNT      30			
Enemy Enemies[MAX_ENEMY_COUNT];

void InitialObject(void);
void PlayerAction(void);
void DrawPlayer(void);
void Draw(void);
void EnemyAction(void);
void DrawEnemy(void);
void CreateShot(int Type, int x, int y);
void ShotAction(void);
void DrawShot(void);
void CheckCrush(void);
int CheckClear(void);
int CheckGameEnd(void);

int main(void)
{
	Initial();				//	ܼ ȭ â ʱȭ
	InitialObject();		//	Ʈ ʱȭ
	
	srand( (unsigned int)time(NULL) );

	while (1) 
	{
		PlayerAction();		//	÷̾ ̵
		EnemyAction();		//	ʹ ̵
		ShotAction();		//	÷̾&ʹ Ѿ ̵

		Draw();				//	Ʈ ܼȭ鿡 
		
		CheckCrush();		//	浹üũ
		
		//	   üũ
		if (CheckGameEnd()) 
			break;

		Sleep(100);
	}

	return 0;
}

void InitialObject(void)
{
	int x = 17;
	int y = 1;
	int i;
	
	//	ʹ̵ ʱȭ
	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		if ( i % 10 == 0 ) 
		{
			x = 17;
			y++;
		}
		
		Enemies[i].Init( x, y, x );
		Enemies[i].SetMoveFlag(1);

		x += ENEMY_SIZE + 1 + 1;
	}
	
	player.Init(39,19);

	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
		Shot[i].UseFlag = 0;
}

void PlayerAction(void)
{
	player.PlayerAction();
}

void DrawPlayer(void)
{
	player.DrawPlayer();
}

void Draw(void)
{
	int i;
	
	for ( i = 0; i < HEIGHT; i++ ) 
	{
		memset(Screen[i], ' ', WIDTH);	
		Screen[i][WIDTH - 1] = 0;		
	}
	
	DrawPlayer();
	
	DrawEnemy();		
	
	DrawShot();			

	for ( i = 0; i < HEIGHT; i++ ) 
	{
		MoveCursor(0, i);		
		printf( Screen[i] );	
	}
}

void EnemyAction(void)
{
	int i;
	
	//	ʹ ̵
	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		Enemies[i].EnemyAction();
	}	
}

void DrawEnemy(void)
{
	int i;
	
	//	ʹ 
	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		Enemies[i].DrawEnemy();
	}
}

void CreateShot(int Type, int x, int y)
{
	int i;

	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{
		if ( Shot[i].UseFlag == 0 ) 
		{
			Shot[i].x = x;
			Shot[i].y = y;
			Shot[i].Type = Type;
			Shot[i].UseFlag = 1;

			return;	
		}
	}
}

void ShotAction(void)
{
	int i;

	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{
		if ( Shot[i].UseFlag ) 
		{
			if ( Shot[i].Type == PLAYER_SHOT ) 
			{
				Shot[i].y--;
				
				if ( Shot[i].y < 0 ) 
					Shot[i].UseFlag = 0;
			}
			else if (Shot[i].Type == ENEMY_SHOT) 
			{
				Shot[i].y++;
				
				if ( Shot[i].y >= HEIGHT ) 
					Shot[i].UseFlag = 0;
			}
		}
	}
}

void DrawShot(void)
{
	int i;

	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{
		if ( Shot[i].UseFlag ) 
		{
			if ( Shot[i].Type == PLAYER_SHOT ) 
				Screen[Shot[i].y][Shot[i].x] = PlayerShot;
			else if ( Shot[i].Type == ENEMY_SHOT )  
				Screen[Shot[i].y][Shot[i].x] = EnemyShot;
		}
	}
}

void CheckCrush(void)
{
	int i, j;

	for ( i = 0; i < MAX_SHOT_COUNT; i++ ) 
	{ 
		if (Shot[i].UseFlag == 0) 
			continue;
		
		if ( Shot[i].Type == PLAYER_SHOT ) 
		{
			for ( j = 0; j < MAX_ENEMY_COUNT; j++ ) 
			{
				if ( Enemies[j].GetLiveFlag() == 0 ) 
					continue;
				
				//	ʹ̿ ÷̾ Ѿ˰ 浹 üũ
				if ( Enemies[j].CollisionWithShot( Shot[i].x, Shot[i].y ) )
				{
					Shot[i].UseFlag = 0;	
					break;
				}
			}
		}
		else if ( Shot[i].Type == ENEMY_SHOT ) 
		{
			if ( player.CollisionWithShot( Shot[i].x, Shot[i].y ) )
			{
				Shot[i].UseFlag = 0;		
			}
		}
	}
}

int CheckClear(void)
{
	int i;
	
	//	ʹ̰  ׾ üũ
	for ( i = 0; i < MAX_ENEMY_COUNT; i++ ) 
	{
		if ( Enemies[i].GetLiveFlag() ) 
			return 0;
	}

	return 1;	
}

int CheckGameEnd(void)
{
	if ( player.GetLiveFlag() == 0 ) 
	{
		system("cls");
		MoveCursor(36, 12);
		printf(" !!");
		Sleep(1000);

		return 1;	
	}
	
	if ( CheckClear() ) 
	{
		system("cls"); 
		MoveCursor(36, 12);
		printf(" ̰!!");
		Sleep(1000);

		return 1;	
	}
	
	return 0;
}